SUPPLIED_LIB = []

def soelim(file)
  if !FileTest.exist?(file) and FileTest.exist?(file+".rb") then
    file += ".rb"
  end
  begin
    f = File.open(file)
  rescue
    return false
  end
  while f.gets
    if /require +(\S+)/ then
      lib = $1
      quote = lib[0].chr
      lib.gsub!(quote,'')
      if SUPPLIED_LIB.include?(lib) then
        next
      end
      if soelim(lib) then
        SUPPLIED_LIB.push(lib)
      else
        print $_
      end
    else
      print $_
    end
  end
  f.close
  true
end



if ARGV.size == 0 then
  STDERR.print "usage: soelim file\n"
  exit
end

print '#!'+`which ruby`
unless soelim(ARGV[0])
  STDERR.print "Can't open ",ARGV[0],"\n"
end
exit

